VERSION 5.00
Begin VB.UserControl ActivityInd 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   570
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   570
   ForeColor       =   &H006A240A&
   ScaleHeight     =   38
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   38
   ToolboxBitmap   =   "ActivityInd.ctx":0000
   Begin VB.PictureBox actBuf 
      AutoRedraw      =   -1  'True
      Height          =   315
      Left            =   120
      ScaleHeight     =   17
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   17
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   315
   End
End
Attribute VB_Name = "ActivityInd"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Activity Indicator Control
' Written by:
'   Michael Karas
'   Carousel Design Solutions
'   www.CarouselDesign.com
'
' You may incorporate all or parts of this program into your own project.
' Keep in mind that you got this code free and as such Carousel Design Solutions
' has no responsibility to you, your customers, or anyone else regarding the use
' of this program code. No support or warrenty of any kind can be provided. All
' liability falls upon the user of this code and thus you must judge the suitability
' of this code to your application and usage.
'
' This control is a progress indicator control that can be placed on a form
' to act as an ongoing activity display. The control can display in one of several
' styles. The activity indicator control can be sized to any suitable size at design
' time. The center point of the control is placed at the center of the rectangular
' control region. The radus is adjusted to that the indicator image fits within the
' narrower of the width or height.
'
' This control the following property settings all of which are read/write at both
' design time and run time. The properties are:
'
'   ActivityInd.Style As eDisplayStyle  Controls the display style of the progress
'                                       control. The choices available are:
'
'                                                 YingYang = 0
'                                                 ClkHands = 1
'                                                 Pointer = 2
'                                                 Arrow = 3
'
'   ActivityInd.BackColor As OLE_COLOR  Specifies the color of the background rectangle
'                                       of the control.
'
'   ActivityInd.ForeColor As OLE_COLOR  Specifies the foreground color of the activity
'                                       indicator or the clock hands.
'
'   ActivityInd.Step As Integer         Specifies the step number of the current indicator
'                                       position as an integer value in range from 0 -> 100%.
'
'

Option Explicit

' specify the Windows API function which is used to copy the progress control image from the
' drawing box to the screen display image.
Private Declare Function BitBlt Lib "gdi32.dll" (ByVal hdcDest As Long, ByVal nXDest As Long, _
                         ByVal nYDest As Long, ByVal nWidth As Long, ByVal nHeight As Long, _
                         ByVal hdcSrc As Long, ByVal nXSrc As Long, ByVal nYSrc As Long, _
                         ByVal dwRop As Long) As Long

Private Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As Any, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Private Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As Any, ByVal nCount As Long) As Long
Private Declare Function FillRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long, ByVal hBrush As Long) As Long
Private Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long

Const ALTERNATE = 1 ' ALTERNATE and WINDING are
Const WINDING = 2 ' constants for FillMode.
Const BLACKBRUSH = 4 ' Constant for brush type.

Private Type COORD
    x As Long
    y As Long
End Type

' specify the progress control display styles
Public Enum eDisplayStyle
    YingYang = 0
    ClkHands = 1
    Pointer = 2
    Arrow = 3
End Enum

'
' declare the constants that represent the default values of the properties
' in the user control
'
Private Const DEFAULT_FORE_COLOR As Long = 5242880      ' RGB(0, 0, 80)
Private Const DEFAULT_BACK_COLOR As Long = &H8000000F   ' Button Face
Private Const DEFAULT_STYLE As Integer = YingYang       ' pie chart type

' local copies of the controls properties
Private mStyle As eDisplayStyle                 ' currently selected style
Private mStep As Integer                        ' step number displayed in 0-100 range

'
' utility function to convert a possible system color to an actual color.
' if it is not a System Color then this returns the same color

Public Function XlatColor(ByVal lColor As Long) As Long

    If (lColor And &H80000000) <> 0 Then
        XlatColor = GetSysColor(lColor And &HFFFFFF)
    Else
        XlatColor = lColor
    End If

End Function

'
' property value routines for getting and setting the states of the user control
'

' property handlers for the Style Property
Public Property Get Style() As eDisplayStyle

    Style = mStyle

End Property

Public Property Let Style(NewStyle As eDisplayStyle)

    mStyle = NewStyle
    UserControl_Paint
    PropertyChanged "Style"
   
End Property

' property handlers for the BackColor Property
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501

    BackColor = UserControl.BackColor

End Property

Public Property Let BackColor(NewBackColor As OLE_COLOR)

    UserControl.BackColor = NewBackColor
    UserControl_Paint
    PropertyChanged "BackColor"
   
End Property

' property handlers for the ForeColor Property
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute ForeColor.VB_UserMemId = -513

    ForeColor = UserControl.ForeColor

End Property

Public Property Let ForeColor(NewForeColor As OLE_COLOR)

    UserControl.ForeColor = NewForeColor
    UserControl_Paint
    PropertyChanged "ForeColor"
   
End Property

' property handlers for the Step Property
Public Property Get Step() As Long

    Step = mStep

End Property

Public Property Let Step(NewStep As Long)
Attribute Step.VB_ProcData.VB_Invoke_PropertyPut = ";Misc"

    If NewStep < 0 Then
        NewStep = 0
    End If
    If NewStep > 100 Then
        NewStep = 100
    End If
    
    If NewStep <> mStep Then
        mStep = NewStep
        UserControl_Paint
    End If
    PropertyChanged "Step"
   
End Property

' Initialize the default states of the controls properties
' this routine sets up some default value copies of the
' properties so that the Write and Read properties methods
' use the same default values as set here.
Private Sub UserControl_InitProperties()
       
    mStyle = DEFAULT_STYLE
    mStep = 0
    UserControl.ForeColor = DEFAULT_FORE_COLOR
    UserControl.BackColor = DEFAULT_BACK_COLOR

End Sub

' display the activity indicator image. this paints into a picture box and
' then the picture box contents is copied to the form display area using
' a fast Windows BLT call.
Private Sub UserControl_Paint()
   
    Dim x As Single                                 ' X center for the image
    Dim y As Single                                 ' Y center for the image
    Dim Radius As Single                            ' radius of the image
    Dim StAng As Single                             ' start angle of the pie image
    Dim Pct As Single                               ' floating point copy of percentage
    Const PI As Single = 3.14159265358979
    Dim orgBrush As Long

    actBuf.BackColor = UserControl.BackColor        ' get copies of the colors into the
    actBuf.ForeColor = UserControl.ForeColor        ' drawing box
     
    ' clear the background of box
    actBuf.Line (actBuf.ScaleLeft, actBuf.ScaleTop)-(actBuf.ScaleWidth, _
                  actBuf.ScaleHeight), UserControl.BackColor, BF
   
    x = (actBuf.ScaleWidth / 2)                     ' get center of the box
    y = (actBuf.ScaleHeight / 2)
    
    If actBuf.ScaleWidth > actBuf.ScaleHeight Then  ' radius is min of
        Radius = (actBuf.ScaleHeight / 2) - 1       ' height and width
    Else
        Radius = (actBuf.ScaleWidth / 2) - 1
    End If
    If Int(Radius / 2) = Radius \ 2 Then
        Radius = Radius - 1
    End If
    
    StAng = (PI / 2) - (((PI * 2) * mStep) / 100#)   ' compute start angle
    If StAng < 0 Then
        StAng = StAng + (PI * 2)
    End If
    
    ' select the display image type based on style property
    Select Case mStyle
    
        ' ying yang image
        Case YingYang
            Dim Arc1 As Single
            Dim Arc2 As Single
            
            Arc1 = StAng
            If Arc1 < 0.005 Then
                Arc1 = 0.005
            End If
        
            Arc2 = StAng + PI
            If Arc2 > (PI * 2) Then
                Arc2 = Arc2 - (PI * 2)
            End If
            If Arc2 < 0.005 Then
                Arc2 = 0.005
            End If
        
            actBuf.FillStyle = 0          ' solid fill style
            actBuf.FillColor = vbWhite
            actBuf.Circle (x, y), Radius, vbBlack, -Arc1, -Arc2
            
            actBuf.FillColor = vbBlack
            actBuf.Circle (x, y), Radius, vbBlack, -Arc2, -Arc1
            
            actBuf.FillColor = vbWhite
            actBuf.Circle (x + ((Radius / 2) * Cos(StAng)), y - ((Radius / 2) * Sin(StAng))), _
                           Radius / 2, vbWhite
            
            actBuf.FillColor = vbBlack
            actBuf.Circle (x - ((Radius / 2) * Cos(StAng)), y + ((Radius / 2) * Sin(StAng))), _
                           Radius / 2, vbBlack
            
            actBuf.FillColor = vbBlack
            actBuf.Circle (x + ((Radius / 2) * Cos(StAng)), y - ((Radius / 2) * Sin(StAng))), _
                           Radius / 10, vbBlack
            
            actBuf.FillColor = vbWhite
            actBuf.Circle (x - ((Radius / 2) * Cos(StAng)), y + ((Radius / 2) * Sin(StAng))), _
                           Radius / 10, vbWhite
            
            actBuf.FillStyle = 1          ' transparent fill style
            actBuf.Circle (x, y), Radius, vbBlack           ' re-draw the outside circle
            

        ' stop clock hands type image
        Case ClkHands
            actBuf.Line (x, y)-(x, y - Radius)               ' draw the line from center to 12:00
            
            If mStep > 0 Then                                ' draw line from center to step position CW
                actBuf.Line (x, y)-(x + (Radius * Cos(StAng)), y - (Radius * Sin(StAng)))
            End If
            
        ' rotating pointer
        Case Pointer
            Dim LftA As Single
            Dim RgtA As Single
            Dim TipX As Single
            Dim TipY As Single
            Dim LftX As Single
            Dim LftY As Single
            Dim RgtX As Single
            Dim RgtY As Single
            Dim Poly(1 To 3) As COORD
            Dim NumCoords As Long
            Dim mBrush As Long
            Dim hRgn As Long
            
            ' compute the left and right tail angles
            LftA = StAng + ((PI * 2) / 3)
            If LftA > (PI * 2) Then
                LftA = LftA - (PI * 2)
            End If
            RgtA = StAng - ((PI * 2) / 3)
            If RgtA < 0 Then
                RgtA = RgtA + (PI * 2)
            End If
            
            ' compute all the current pointer coordinates
            TipX = x + (Radius * Cos(StAng))
            TipY = y - (Radius * Sin(StAng))
            
            LftX = x - ((Radius * Sin(LftA)) / 10)
            LftY = y - ((Radius * Cos(LftA)) / 10)
        
            RgtX = x + ((Radius * Sin(RgtA)) / 10)
            RgtY = y + ((Radius * Cos(RgtA)) / 10)
            
            ' assign the points to the polygon as a triangle
            Poly(1).x = TipX
            Poly(1).y = TipY
            Poly(2).x = LftX
            Poly(2).y = LftY
            Poly(3).x = RgtX
            Poly(3).y = RgtY
            NumCoords = 3
            
            mBrush = CreateSolidBrush(XlatColor(UserControl.ForeColor))     ' Create a solid brush
            orgBrush = SelectObject(actBuf.hdc, mBrush)          ' Select the brush into the device context
            
            hRgn = CreatePolygonRgn(Poly(1), NumCoords, ALTERNATE) ' Creates region to fill with color.
            If hRgn Then     ' If the creation of the region was successful then color.
                FillRgn actBuf.hdc, hRgn, mBrush
            End If
            DeleteObject hRgn
            SelectObject actBuf.hdc, orgBrush          ' Reselect original brush into device context
            DeleteObject mBrush     ' Delete the solid brush
            
            ' draw the pointer outline in black
            actBuf.ForeColor = vbBlack
            Polygon actBuf.hdc, Poly(1), NumCoords
            
        ' chaser arrow
        Case Arrow
            Dim EnAng As Single                     ' end angle
            Dim ArcB As Single
            Dim ArcE As Single
            Dim TriAng(1 To 3) As COORD
            Dim TriCoords As Long
            Dim aBrush As Long
            Dim aRgn As Long
            Const ARROW_TOP As Single = 1#
            Const ARROW_OUT As Single = 0.89
            Const ARROW_TIP As Single = 0.78
            Const ARROW_END As Single = 0.66
            Const ARROW_INP As Single = 0.45
            Const ARROW_BOT As Single = 0.33
            Const ANG_OVERLAP As Single = 0.04
            
            EnAng = StAng + ((25 * (PI * 2)) / 32)
            If EnAng > (PI * 2) Then
                EnAng = EnAng - (PI * 2)
            End If
            
            ' work on the arrow shaft
            ArcB = StAng
            If ArcB < 0.005 Then
                ArcB = 0.005
            End If
        
            ArcE = EnAng
            If ArcE > (PI * 2) Then
                ArcE = ArcE - (PI * 2)
            End If
            If ArcE < 0.005 Then
                ArcE = 0.005
            End If
            
            actBuf.FillStyle = 0                    ' solid fill style
            actBuf.FillColor = UserControl.ForeColor
            actBuf.Circle (x, y), Radius * ARROW_OUT, UserControl.ForeColor, -ArcB, -ArcE
            actBuf.Circle (x, y), Radius * ARROW_OUT, vbBlack, ArcB, ArcE
            
            actBuf.FillColor = UserControl.BackColor
            actBuf.Circle (x, y), Radius * ARROW_INP, UserControl.BackColor
            actBuf.Circle (x, y), Radius * ARROW_INP, vbBlack, ArcB, ArcE
            
            ' work on the arrow head
            ArcB = StAng - ((1 * (PI * 2)) / 10)
            If ArcB < 0 Then
                ArcB = ArcB + (PI * 2)
            End If
            
            TriAng(1).x = x + ((Radius * ARROW_TOP) * Cos(StAng + ANG_OVERLAP))
            TriAng(1).y = y - ((Radius * ARROW_TOP) * Sin(StAng + ANG_OVERLAP))
            TriAng(2).x = x + ((Radius * ARROW_BOT) * Cos(StAng + ANG_OVERLAP))
            TriAng(2).y = y - ((Radius * ARROW_BOT) * Sin(StAng + ANG_OVERLAP))
            TriAng(3).x = x + ((Radius * ARROW_TIP) * Cos(ArcB))
            TriAng(3).y = y - ((Radius * ARROW_TIP) * Sin(ArcB))
            TriCoords = 3
            
            aBrush = CreateSolidBrush(XlatColor(UserControl.ForeColor))   ' Create a solid brush
            orgBrush = SelectObject(actBuf.hdc, aBrush)         ' Select the brush into the device context
            aRgn = CreatePolygonRgn(TriAng(1), TriCoords, ALTERNATE) ' Creates region to fill with color.
            If aRgn Then     ' If the creation of the region was successful then color.
                FillRgn actBuf.hdc, aRgn, aBrush
            End If
            DeleteObject aRgn
            SelectObject actBuf.hdc, orgBrush          ' Reselect original brush into device context
            DeleteObject aBrush                         ' Delete the solid brush
            
            actBuf.ForeColor = vbBlack      ' draw the pointer outline in black
            actBuf.FillColor = UserControl.ForeColor
            
            actBuf.Line (TriAng(2).x, TriAng(2).y)- _
                (x + ((Radius * ARROW_INP) * Cos(StAng + ANG_OVERLAP)), _
                 y - ((Radius * ARROW_INP) * Sin(StAng + ANG_OVERLAP)))
            actBuf.Line (TriAng(1).x, TriAng(1).y)- _
                (x + ((Radius * ARROW_OUT) * Cos(StAng + ANG_OVERLAP)), _
                 y - ((Radius * 0.875) * Sin(StAng + ANG_OVERLAP)))
            actBuf.Line (TriAng(2).x, TriAng(2).y)-(TriAng(3).x, TriAng(3).y)
            actBuf.Line (TriAng(1).x, TriAng(1).y)-(TriAng(3).x, TriAng(3).y)
            
            ' work on the arrow tail
            ArcE = EnAng - ((1 * (PI * 2)) / 18)
            If ArcE < 0 Then
                ArcE = ArcE + (PI * 2)
            End If
            
            TriAng(1).x = x + ((Radius * ARROW_OUT) * Cos(EnAng + ANG_OVERLAP))
            TriAng(1).y = y - ((Radius * ARROW_OUT) * Sin(EnAng + ANG_OVERLAP))
            TriAng(2).x = x + ((Radius * ARROW_INP) * Cos(EnAng + ANG_OVERLAP))
            TriAng(2).y = y - ((Radius * ARROW_INP) * Sin(EnAng + ANG_OVERLAP))
            TriAng(3).x = x + ((Radius * ARROW_END) * Cos(ArcE))
            TriAng(3).y = y - ((Radius * ARROW_END) * Sin(ArcE))
            TriCoords = 3

            actBuf.FillStyle = 0                    ' solid fill style
            aBrush = CreateSolidBrush(XlatColor(UserControl.BackColor))   ' Create a solid brush
            orgBrush = SelectObject(actBuf.hdc, aBrush)         ' Select the brush into the device context
            aRgn = CreatePolygonRgn(TriAng(1), TriCoords, ALTERNATE) ' Creates region to fill with color.
            If aRgn Then     ' If the creation of the region was successful then color.
                FillRgn actBuf.hdc, aRgn, aBrush
            End If
            DeleteObject aRgn
            SelectObject actBuf.hdc, orgBrush          ' Reselect original brush into device context
            DeleteObject aBrush             ' Delete the solid brush
            
            actBuf.ForeColor = vbBlack      ' draw the tail outline in black
            actBuf.Line (x + (Radius * ARROW_INP * Cos(EnAng)), _
                         y - (Radius * ARROW_INP * Sin(EnAng)))-(TriAng(3).x, TriAng(3).y)
            actBuf.Line (x + (Radius * ARROW_OUT * Cos(EnAng)), _
                         y - (Radius * ARROW_OUT * Sin(EnAng)))-(TriAng(3).x, TriAng(3).y)
    
    End Select

    ' blast the drawing box contents to the form client rectangle
    BitBlt UserControl.hdc, UserControl.ScaleLeft, UserControl.ScaleTop, UserControl.ScaleWidth, _
                            UserControl.ScaleHeight, actBuf.hdc, actBuf.ScaleLeft, actBuf.ScaleTop, vbSrcCopy

End Sub

' routine to support the getting of the current properties values from
' the controls host container property bag
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    mStyle = PropBag.ReadProperty("Style", DEFAULT_STYLE)
    mStep = PropBag.ReadProperty("Step", 0)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", DEFAULT_BACK_COLOR)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", DEFAULT_FORE_COLOR)
   
End Sub

' routine to support the saving of the current properties values into
' the controls host container property bag.
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    PropBag.WriteProperty "Style", mStyle, DEFAULT_STYLE
    PropBag.WriteProperty "Step", mStep, 0
    PropBag.WriteProperty "BackColor", UserControl.BackColor, DEFAULT_BACK_COLOR
    PropBag.WriteProperty "ForeColor", UserControl.ForeColor, DEFAULT_FORE_COLOR
   
End Sub

' this routine re-sizes the drawing buffer picture box to match the size of the client region
' of the progress control
Private Sub UserControl_Resize()

    actBuf.Move 0, 0, UserControl.Width / Screen.TwipsPerPixelX, UserControl.Height / Screen.TwipsPerPixelY

End Sub
